unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, rcTreeView, ImgList, StdCtrls, MMSystem, Math;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    ImageList1: TImageList;
    rcTreeViewFont: TrcTreeView;
    rcTreeViewNode: TrcTreeView;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    rcTreeViewSpeed: TrcTreeView;
    rcTreeViewData: TrcTreeView;
    Button4: TButton;
    Button5: TButton;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure rcTreeViewDataCreateNode(Sender: TObject;
      var NodeClass: TrcTreeViewNodeClass);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure rcTreeViewDataChange(Sender: TObject; Node: TrcTreeViewNode);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure AddNodes(Node: TrcTreeViewNode; Levels, Level, Nodes: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  //Declarations for new properties of a node
  TMyNode = class(TrcTreeViewNode)
  private
    FMyInteger: Integer;
    FMyString: string;
    FMyStringSize: integer;
    procedure SetMyInteger(const Value: Integer);
    procedure SetMyString(const Value: string);
    procedure SetMyStringSize(const Value: integer);
  protected
    Procedure ReadData(Stream: TStream; Info: PNodeInfo); override;
    Procedure WriteData(Stream: TStream; Info: PNodeInfo); override;
  public
    property MyInteger : Integer read FMyInteger write SetMyInteger;
    property MyString : string read FMyString write SetMyString;
    //Records the length of MyString in order to save/load the tree view.
    property MyStringSize : integer read FMyStringSize write SetMyStringSize;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  rcTreeViewData.SaveToFile('test.rct',True);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  rcTreeViewData.LoadFromFile('test.rct');
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  node : TMyNode;
begin
  node := TMyNode.Create(rcTreeViewData.Items);
  rcTreeViewData.Items.Add(node,'Mynode');
end;

procedure TForm1.rcTreeViewDataChange(Sender: TObject; Node: TrcTreeViewNode);
begin
  if rcTreeViewData.Selected <> nil then
  begin
    Edit1.Text := IntToStr(TmyNode(rcTreeViewData.Selected).MyInteger);
    Edit2.Text := TmyNode(rcTreeViewData.Selected).MyString;
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if rcTreeViewData.Selected <> nil then
    TmyNode(rcTreeViewData.Selected).MyInteger :=  StrToInt(Edit1.Text);
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
 if rcTreeViewData.Selected <> nil then
   TmyNode(rcTreeViewData.Selected).MyString := Edit2.Text;
end;

{ TMyNode }

procedure TForm1.rcTreeViewDataCreateNode(Sender: TObject; var NodeClass: TrcTreeViewNodeClass);
begin
  NodeClass := TMyNode;  //Important, tells the tree view using new node class while creating a new node.
end;

procedure TMyNode.SetMyInteger(const Value: Integer);
begin
  FMyInteger := Value;
end;

procedure TMyNode.SetMyString(const Value: string);
begin
  FMyString := Value;
  SetMyStringSize(Length(FMyString));  //Update MySting's length value
end;

procedure TMyNode.SetMyStringSize(const Value: integer);
begin
  FMyStringSize := Value;
end;

procedure TMyNode.ReadData(Stream: TStream; Info: PNodeInfo);
var
  StrBuffer: PChar;
  i : integer;
begin
  inherited;
  Stream.ReadBuffer(i, SizeOf(i));
  MyInteger := i;
  Stream.ReadBuffer(i, SizeOf(i));
  MyStringSize := i;
  if MyStringSize > 0 then begin
    StrBuffer:= StrAlloc(MyStringSize+1);
    StrBuffer[MyStringSize]:= #0;
    Stream.ReadBuffer(StrBuffer^, MyStringSize);
    MyString:= StrPas(StrBuffer);
    StrDispose(StrBuffer);
  end else
    MyString:= '';
end;

procedure TMyNode.WriteData(Stream: TStream; Info: PNodeInfo);
begin
  inherited;
  Stream.WriteBuffer(MyInteger, SizeOf(MyInteger));
  Stream.WriteBuffer(MyStringSize, SizeOf(MyStringSize));
  if MyStringSize > 0 then
    Stream.WriteBuffer(PChar(MyString)^, MyStringSize);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  rcTreeViewSpeed.Items.Clear;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  TimeCount: DWORD;
  i, levels, nodes: Integer;
  CurrentNode : TrcTreeViewNode;
begin
  Screen.Cursor := crHourGlass;
  try
    levels := StrToInt(Trim(Edit3.Text));
    nodes := StrToInt(Trim(Edit4.Text));
    TimeCount := timeGetTime;
    rcTreeViewSpeed.Items.BeginUpdate;
    for i := 1 to nodes do begin
      CurrentNode := rcTreeViewSpeed.Items.Add(nil, 'Node');
      if Levels > 1 then
        AddNodes(CurrentNode, Levels, Levels - 1, Nodes);
    end;
    rcTreeViewSpeed.FullExpand;
    rcTreeViewSpeed.Items.GetFirstNode.MakeVisible;
    rcTreeViewSpeed.Items.EndUpdate;
    Label5.Caption := 'Time: ' + IntToStr(timeGetTime - TimeCount) + ' ms';
    Label6.Caption := 'Nodes: ' + IntToStr(rcTreeViewSpeed.Items.Count);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.AddNodes(Node: TrcTreeViewNode; Levels, Level, Nodes: Integer);
var
  i: Integer;
  Child : TrcTreeViewNode;
begin
  with rcTreeViewSpeed.Items do
  begin
    Node.BeginUpdate;
    for I := 1 to Nodes do
    begin
      Child := AddChild(Node, 'Child');
      if Level > 1 then AddNodes(Child, Levels, Level - 1, Nodes);
    end;
    Node.EndUpdate;
  end;
end;

end.
